<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>

<div class="map-summary-state-popover col-xs-12 animated slideInRight slightBorder"
     ng-if="summaryState"
     ng-click="hideTooltip($event)"
     ng-mouseover="stopInterval()"
     ng-mouseleave="startInterval()">
    <section>
        <article ng-if="iconType == 'host'">
            <div class="bg-color-white padding-top-10 padding-left-10 padding-bottom-10">
                <header>
                    <h4 class="bold txt-color-blueDark">
                        <i class="fa fa-desktop fa-lg txt-color-blueDark"></i>
                        <?php echo __('Host'); ?>
                    </h4>
                    <div class="col-lg-12 no-padding no-margin">
                        <div class="tooltipProgressBar" style="width: {{percentValue}}%;"></div>
                    </div>
                </header>
                <div class="txt-color-blueDark font-xs padding-top-10 padding-bottom-10">
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Hostname'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <a ui-sref="HostsBrowser({uuid: summaryState.Host.uuid})">
                                {{summaryState.Host.display_name}}
                            </a>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('State'); ?>
                        </div>
                        <div ng-show="summaryState.Hoststatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white text-capitalize bg-{{(summaryState.Hoststatus.isHardstate)?summaryState.Hoststatus.humanState:summaryState.Hoststatus.humanState+'-soft'}}">
                            <span class="padding-5">{{summaryState.Hoststatus.humanState}}</span>
                            <i ng-show="summaryState.Hoststatus.problemHasBeenAcknowledged" class="fa fa-user"></i>
                            <i ng-show="summaryState.Hoststatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>
                        </div>
                        <div ng-hide="summaryState.Hoststatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white bg-primary">
                            <?php echo __('Not in monitoring'); ?>
                            <i class="fa fa-eye-slash"></i>
                        </div>
                    </div>
                    <div ng-show="summaryState.Hoststatus.isInMonitoring">
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Output'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                <div class="cropText"
                                     ng-bind-html="summaryState.Hoststatus.outputHtml | trustAsHtml"></div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Perfdata'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Hoststatus.perfdata}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Current attempt'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Hoststatus.current_check_attempt}}/{{summaryState.Hoststatus.max_check_attempts}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Last check'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Hoststatus.lastCheck}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Next check'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Hoststatus.nextCheck}}
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Summary State'); ?>
                        </div>
                        <div ng-if="summaryState.Services.length > 0"
                             class="col-lg-8 text-center txt-color-white text-capitalize bg-{{summaryState.Services[0].Servicestatus.humanState}}">
                            {{summaryState.Services[0].Servicestatus.humanState}}

                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Summary Output'); ?>
                        </div>
                        <div class="col-lg-9">
                            <div class="row">
                                <div class="col-lg-12 no-padding">
                                    <?php echo __('Services: '); ?> {{summaryState.ServiceSummary.total}}
                                </div>
                                <div class="col-lg-11">

                                    <div class="btn-group btn-group-xs" style="width: 100%;"
                                         ng-show="summaryState.ServiceSummary.total > 0">
                                        <button type="button" class="btn btn-success "
                                                ui-sref="ServicesIndex({id: summaryState.ServiceIdsGroupByState[0]})">
                                            {{summaryState.ServiceSummary.state[0]}}
                                        </button>
                                        <button type="button" class="btn btn-warning "
                                                ui-sref="ServicesIndex({id: summaryState.ServiceIdsGroupByState[1]})">
                                            {{summaryState.ServiceSummary.state[1]}}
                                        </button>
                                        <button type="button" class="btn btn-danger "
                                                ui-sref="ServicesIndex({id: summaryState.ServiceIdsGroupByState[2]})">
                                            {{summaryState.ServiceSummary.state[2]}}
                                        </button>
                                        <button type="button" class="btn btn-secondary "
                                                ui-sref="ServicesIndex({id: summaryState.ServiceIdsGroupByState[3]})">
                                            {{summaryState.ServiceSummary.state[3]}}
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-20" ng-show="summaryState.Services.length > 0">
                        <div class="col-lg-4">
                            <?php echo __('Service'); ?>
                        </div>
                        <div class="col-lg-3 no-padding">
                            <?php echo __('State'); ?>
                        </div>
                        <div class="col-lg-4">
                            <?php echo __('Output'); ?>
                        </div>
                    </div>
                    <div class="row padding-top-5" ng-repeat="service in summaryState.Services">
                        <!-- Servicename -->
                        <div class="col-lg-4 cropText" title="{{service.Service.display_name}}">
                            <a ui-sref="ServicesBrowser({hostuuid:summaryState.Host.uuid, serviceuuid:service.Service.uuid})">
                                {{service.Service.display_name}}
                            </a>
                        </div>
                        <!-- State -->
                        <div ng-show="service.Servicestatus.isInMonitoring"
                             class="col-lg-3 text-center txt-color-white text-capitalize bg-{{(service.Servicestatus.isHardstate)?service.Servicestatus.humanState:service.Servicestatus.humanState+'-soft'}}">
                            {{service.Servicestatus.humanState}}
                            <i ng-show="service.Servicestatus.problemHasBeenAcknowledged"
                               class="fa fa-user"></i>
                            <i ng-show="service.Servicestatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>
                        </div>
                        <div ng-hide="service.Servicestatus.isInMonitoring"
                             class="col-lg-3 text-center txt-color-white bg-primary">
                            <?php echo __('Not in monitoring'); ?>
                            <i class="fa fa-eye-slash"></i>
                        </div>
                        <!-- Output -->
                        <div class="col-lg-4 cropText">
                            <div class="cropText"
                                 ng-bind-html="service.Servicestatus.outputHtml | trustAsHtml"></div>
                        </div>
                    </div>
                </div>
            </div>
        </article>
        <article ng-if="iconType == 'service'">
            <div class="bg-color-white padding-top-10 padding-left-10 padding-bottom-10">
                <header>
                    <h4 class="bold txt-color-blueDark">
                        <i class="fa fa-cog fa-lg txt-color-blueDark"></i>
                        <?php echo __('Service'); ?>
                        <span class="text-danger" ng-if="summaryState.Service.disabled">
                                <?php echo __(' (DISABLED)'); ?>
                            </span>
                    </h4>
                    <div class="col-lg-12 no-padding">
                        <div class="tooltipProgressBar" style="width: {{percentValue}}%;"></div>
                    </div>
                </header>
                <div class="txt-color-blueDark font-xs padding-top-10 padding-bottom-10">
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Hostname'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <a ui-sref="HostsBrowser({uuid: summaryState.Host.uuid})">
                                {{summaryState.Host.display_name}}
                            </a>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Host state'); ?>
                        </div>
                        <div ng-show="summaryState.Hoststatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white text-capitalize bg-{{(summaryState.Hoststatus.isHardstate)?summaryState.Hoststatus.humanState:summaryState.Hoststatus.humanState+'-soft'}}">
                            <span class="padding-5">{{summaryState.Hoststatus.humanState}}</span>
                            <i ng-show="summaryState.Hoststatus.problemHasBeenAcknowledged" class="fa fa-user"></i>
                            <i ng-show="summaryState.Hoststatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>
                        </div>
                        <div ng-hide="summaryState.Hoststatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white bg-primary">
                            <?php echo __('Not in monitoring'); ?>
                            <i class="fa fa-eye-slash"></i>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Service'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <a ui-sref="ServicesBrowser({hostuuid:summaryState.Host.uuid, serviceuuid:summaryState.Service.uuid})">
                                {{summaryState.Service.display_name}}
                            </a>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('State'); ?>
                        </div>
                        <div ng-show="summaryState.Servicestatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white text-capitalize bg-{{(summaryState.Servicestatus.isHardstate)?summaryState.Servicestatus.humanState:summaryState.Servicestatus.humanState+'-soft'}}">
                            <span class="padding-5">{{summaryState.Servicestatus.humanState}}</span>
                            <i ng-show="summaryState.Servicestatus.problemHasBeenAcknowledged"
                               class="fa fa-user"></i>
                            <i ng-show="summaryState.Servicestatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>
                        </div>
                        <div ng-hide="summaryState.Servicestatus.isInMonitoring"
                             class="col-lg-8 text-center txt-color-white bg-primary">
                            <?php echo __('Not in monitoring'); ?>
                            <i class="fa fa-eye-slash"></i>
                        </div>
                    </div>
                    <div ng-show="summaryState.Servicestatus.isInMonitoring">
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Output'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                <div class="cropText"
                                     ng-bind-html="summaryState.Servicestatus.outputHtml | trustAsHtml"></div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Perfdata'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Servicestatus.perfdata}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Current attempt'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Servicestatus.current_check_attempt}}/{{summaryState.Servicestatus.max_check_attempts}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Last check'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Servicestatus.lastCheck}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Next check'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Servicestatus.nextCheck}}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-3">
                                <?php echo __('Last state change'); ?>
                            </div>
                            <div class="col-lg-8 no-padding">
                                {{summaryState.Servicestatus.last_state_change}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </article>
        <article ng-if="iconType == 'hostgroup'">
            <div class="bg-color-white padding-top-10 padding-left-10 padding-bottom-10">
                <header>
                    <h4 class="bold txt-color-blueDark">
                        <i class="fa fa-sitemap fa-lg txt-color-blueDark"></i>
                        <?php echo __('Host group'); ?>
                    </h4>
                    <div class="col-lg-12 no-padding">
                        <div class="tooltipProgressBar" style="width: {{percentValue}}%;"></div>
                    </div>
                </header>
                <div class="txt-color-blueDark font-xs padding-top-10 padding-bottom-10">
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Host group name'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            {{summaryState.Hostgroup.name}}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Description'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            {{summaryState.Hostgroup.description}}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Summary state'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div
                                    class="text-center txt-color-white text-capitalize bg-{{ summaryState.CumulatedHumanState}}">
                                {{summaryState.CumulatedHumanState}}
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-4">
                            <?php echo __('Summary output'); ?>
                        </div>
                        <div class="col-lg-4 no-padding">
                            <?php echo __('Hosts: '); ?>{{summaryState.Hostgroup.HostSummary.total}}
                        </div>
                        <div class="col-lg-4 no-padding">
                            <?php echo __('Services: '); ?>{{summaryState.Hostgroup.TotalServiceSummary.total}}
                        </div>
                    </div>

                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Hosts overview'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div class="btn-group btn-group-xs" style="width: 100%;">
                                <button type="button" class="btn btn-success ">
                                    {{summaryState.Hostgroup.HostSummary.state[0]}}
                                </button>
                                <button type="button" class="btn btn-danger ">
                                    {{summaryState.Hostgroup.HostSummary.state[1]}}
                                </button>
                                <button type="button" class="btn btn-secondary ">
                                    {{summaryState.Hostgroup.HostSummary.state[2]}}
                                </button>
                            </div>
                        </div>
                    </div>

                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Services overview'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div class="btn-group btn-group-xs" style="width: 100%;">
                                <button type="button" class="btn btn-success ">
                                    {{summaryState.Hostgroup.TotalServiceSummary.state[0]}}
                                </button>
                                <button type="button" class="btn btn-warning ">
                                    {{summaryState.Hostgroup.TotalServiceSummary.state[1]}}
                                </button>
                                <button type="button" class="btn btn-danger ">
                                    {{summaryState.Hostgroup.TotalServiceSummary.state[2]}}
                                </button>
                                <button type="button" class="btn btn-secondary ">
                                    {{summaryState.Hostgroup.TotalServiceSummary.state[3]}}
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10" ng-repeat="host in summaryState.Hosts">
                        <div class="col-lg-3 cropText">
                            <a ui-sref="HostsBrowser({uuid: host.Host.host_uuid})">
                                {{host.Host.name}}
                            </a>
                        </div>
                        <div ng-show="host.Hoststatus.isInMonitoring"
                             class="col-lg-4 text-center txt-color-white text-capitalize bg-{{(host.Hoststatus.isHardstate)?host.Hoststatus.humanState:host.Hoststatus.humanState+'-soft'}}">
                            {{host.Hoststatus.humanState}}
                            <i ng-show="host.Hoststatus.problemHasBeenAcknowledged"
                               class="fa fa-user"></i>
                            <i ng-show="host.Hoststatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>
                        </div>
                        <div ng-hide="host.Hoststatus.isInMonitoring"
                             class="col-lg-4 text-center txt-color-white bg-primary">
                            <?php echo __('Not in monitoring'); ?>
                            <i class="fa fa-eye-slash"></i>
                        </div>
                        <div class="col-lg-4 offset-lg-1 no-padding">
                            <div class="btn-group btn-group-xs" role="group">
                                <button class="btn btn-success state-button-small font-sm">
                                    {{host.ServiceSummary.state[0]}}
                                </button>
                                <button class="btn btn-warning state-button-small font-sm">
                                    {{host.ServiceSummary.state[1]}}
                                </button>
                                <button class="btn btn-danger state-button-small font-sm">
                                    {{host.ServiceSummary.state[2]}}
                                </button>
                                <button class="btn btn-default state-button-small font-sm">
                                    {{host.ServiceSummary.state[3]}}
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </article>
        <article ng-if="iconType == 'servicegroup'">
            <div class="bg-color-white padding-top-10 padding-left-10 padding-bottom-10">
                <header>
                    <h4 class="bold txt-color-blueDark">
                        <i class="fa fa-cogs fa-lg txt-color-blueDark"></i>
                        <?php echo __('Service group'); ?>
                    </h4>
                    <div class="col-lg-12 no-padding">
                        <div class="tooltipProgressBar" style="width: {{percentValue}}%;"></div>
                    </div>
                </header>
                <div class="txt-color-blueDark font-xs padding-top-10 padding-bottom-10">
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Service group name'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            {{summaryState.Servicegroup.name}}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Description'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            {{summaryState.Servicegroup.description}}
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Summary state'); ?>
                        </div>
                        <div class="col-lg-8 no-padding" ng-show="summaryState.ServiceSummary.total > 0">
                            <div
                                    class="text-center txt-color-white text-capitalize bg-{{ summaryState.CumulatedHumanState}}">
                                {{summaryState.CumulatedHumanState}}
                            </div>
                        </div>
                        <div class="col-lg-8 no-padding" ng-show="summaryState.ServiceSummary.total == 0">
                            <div class="text-center txt-color-white text-capitalize bg-primary">
                                {{summaryState.CumulatedHumanState}}
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Summary output'); ?>
                        </div>
                        <div class="col-lg-4 no-padding">
                            <?php echo __('Services: '); ?>{{summaryState.ServiceSummary.total}}
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Services overview'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div class="btn-group btn-group-xs" style="width: 100%;"
                                 ng-show="summaryState.ServiceSummary.total > 0">
                                <button type="button" class="btn btn-success ">
                                    {{summaryState.ServiceSummary.state[0]}}
                                </button>
                                <button type="button" class="btn btn-warning ">
                                    {{summaryState.ServiceSummary.state[1]}}
                                </button>
                                <button type="button" class="btn btn-danger ">
                                    {{summaryState.ServiceSummary.state[2]}}
                                </button>
                                <button type="button" class="btn btn-secondary ">
                                    {{summaryState.ServiceSummary.state[3]}}
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-20" ng-show="summaryState.Services.length > 0">
                        <div class="col-lg-5">
                            <?php echo __('Service'); ?>
                        </div>
                        <div class="col-lg-2 no-padding">
                            <?php echo __('State'); ?>
                        </div>
                        <div class="col-lg-4">
                            <?php echo __('Output'); ?>
                        </div>
                    </div>
                    <div class="row padding-top-10" ng-repeat="service in summaryState.Services">
                        <div class="col-lg-5 cropText"
                             title="{{service.Service.HostMapping.display_name}}/{{service.Service.ServiceMapping.display_name}}">

                            <a ui-sref="ServicesBrowser({hostuuid: service.Service.Servicestatus.hostname, serviceuuid: service.Service.Servicestatus.service_description})">
                                {{service.Service.HostMapping.display_name}}/{{service.Service.ServiceMapping.display_name}}
                            </a>
                        </div>
                        <div ng-show="service.Servicestatus.isInMonitoring"
                             class="col-lg-2 text-center txt-color-white text-capitalize bg-{{(service.Servicestatus.isHardstate)?service.Servicestatus.humanState:service.Servicestatus.humanState+'-soft'}}">
                            {{service.Servicestatus.humanState}}
                            <i ng-show="service.Servicestatus.problemHasBeenAcknowledged"
                               class="fa fa-user"></i>
                            <i ng-show="service.Servicestatus.scheduledDowntimeDepth > 0"
                               class="fa fa-power-off"></i>&nbsp;
                        </div>
                        <div ng-hide="service.Servicestatus.isInMonitoring"
                             class="col-lg-2 text-center txt-color-white bg-primary">
                            <i class="fa fa-eye-slash"></i>
                        </div>
                        <div class="col-lg-4 cropText">
                            <div class="cropText"
                                 ng-bind-html="service.Servicestatus.outputHtml | trustAsHtml"></div>
                        </div>
                    </div>
                </div>
            </div>
        </article>
        <article ng-if="iconType == 'map'">
            <div class="bg-color-white padding-top-10 padding-left-10 padding-bottom-10">
                <header>
                    <h4 class="bold txt-color-blueDark">
                        <i class="fas fa-map-marked-alt fa-lg txt-color-blueDark"></i>
                        <?php echo __('Map'); ?>
                    </h4>
                    <div class="col-lg-12 no-padding">
                        <div class="tooltipProgressBar" style="width: {{percentValue}}%;"></div>
                    </div>
                </header>
                <div class="txt-color-blueDark font-xs padding-top-10 padding-bottom-10">
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Map name'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <a ui-sref="MapeditorsView({id: summaryState.Map.object_id})">
                                {{summaryState.Map.name}}
                            </a>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-3">
                            <?php echo __('Map title'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            {{summaryState.Map.title}}
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-3">
                            <?php echo __('Summary state'); ?>
                        </div>
                        <div class="col-lg-8 no-padding"
                             ng-show="summaryState.HostSummary.total > 0|| summaryState.ServiceSummary.total > 0">
                            <div
                                    class="text-center txt-color-white text-capitalize bg-{{ summaryState.CumulatedHumanState}}">
                                {{summaryState.CumulatedHumanState}}
                            </div>
                        </div>
                        <div class="col-lg-8 no-padding"
                             ng-show="summaryState.HostSummary.total == 0 && summaryState.ServiceSummary.total == 0">
                            <div class="text-center txt-color-white text-capitalize bg-primary">
                                {{summaryState.CumulatedHumanState}}
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10" ng-show="summaryState.HostSummary.total > 0|| summaryState.ServiceSummary.total > 0">
                        <div class="col-lg-3">
                            <?php echo __('Summary output'); ?>
                        </div>
                        <div class="col-lg-4 no-padding">
                            <?php echo __('Hosts: '); ?>{{summaryState.HostSummary.total}}
                        </div>
                        <div class="col-lg-4 no-padding">
                            <?php echo __('Services: '); ?>{{summaryState.ServiceSummary.total}}
                        </div>
                    </div>
                    <div class="row padding-top-10" ng-show="summaryState.HostSummary.total > 0">
                        <div class="col-lg-3">
                            <?php echo __('Hosts overview'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div class="btn-group btn-group-xs" style="width: 100%;"
                                 ng-show="summaryState.ServiceSummary.total > 0">
                                <button type="button" class="btn btn-success ">
                                    {{summaryState.HostSummary.state[0]}}
                                </button>
                                <button type="button" class="btn btn-danger ">
                                    {{summaryState.HostSummary.state[1]}}
                                </button>
                                <button type="button" class="btn btn-secondary ">
                                    {{summaryState.HostSummary.state[2]}}
                                </button>
                            </div>
                        </div>
                    </div>

                    <div class="row padding-top-10" ng-show="summaryState.ServiceSummary.total > 0">
                        <div class="col-lg-3">
                            <?php echo __('Services overview'); ?>
                        </div>
                        <div class="col-lg-8 no-padding">
                            <div class="btn-group btn-group-xs" style="width: 100%;"
                                 ng-show="summaryState.ServiceSummary.total > 0">
                                <button type="button" class="btn btn-success ">
                                    {{summaryState.ServiceSummary.state[0]}}
                                </button>
                                <button type="button" class="btn btn-warning ">
                                    {{summaryState.ServiceSummary.state[1]}}
                                </button>
                                <button type="button" class="btn btn-danger ">
                                    {{summaryState.ServiceSummary.state[2]}}
                                </button>
                                <button type="button" class="btn btn-secondary ">
                                    {{summaryState.ServiceSummary.state[3]}}
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10">
                        <div class="col-lg-12">
                                <span class="bold">
                                    <?php echo __('Host and services are not in state UP/OK'); ?>
                                </span>
                            <span class="text-info">(
                                    <i class="fa fa-info-circle"></i>
                                    <?php echo __(' maximum 20'); ?>
                                </span>)
                        </div>
                    </div>
                    <div ng-if="summaryState.NotOkHosts.length > 0 || summaryState.NotOkServices.length">
                        <div class="row padding-top-20" ng-show="summaryState.NotOkHosts.length > 0">
                            <div class="col-lg-4">
                                <?php echo __('Host'); ?>
                            </div>
                            <div class="col-lg-3 no-padding">
                                <?php echo __('State'); ?>
                            </div>
                            <div class="col-lg-4">
                                <?php echo __('Output'); ?>
                            </div>
                        </div>
                        <div class="row padding-top-5" ng-repeat="notOkHost in summaryState.NotOkHosts">
                            <div class="col-lg-4 cropText" title="{{notOkHost.Host.hostname}}">
                                <a ui-sref="HostsBrowser({uuid: notOkHost.Host.host_mapping.uuid})">
                                    {{notOkHost.Host.host_mapping.display_name}}
                                </a>
                            </div>
                            <div ng-show="notOkHost.Hoststatus.isInMonitoring"
                                 class="col-lg-3 text-center txt-color-white text-capitalize bg-{{(notOkHost.Hoststatus.isHardstate)?notOkHost.Hoststatus.humanState:notOkHost.Hoststatus.humanState+'-soft'}}">
                                {{notOkHost.Hoststatus.humanState}}
                                <i ng-show="notOkHost.Hoststatus.problemHasBeenAcknowledged"
                                   class="fa fa-user"></i>
                                <i ng-show="notOkHost.Hoststatus.scheduledDowntimeDepth > 0"
                                   class="fa fa-power-off"></i>
                            </div>
                            <div ng-hide="notOkHost.Hoststatus.isInMonitoring"
                                 class="col-lg-3 text-center txt-color-white bg-primary">
                                <?php echo __('Not in monitoring'); ?>
                                <i class="fa fa-eye-slash"></i>
                            </div>
                            <div class="col-lg-4 cropText" title="notOkHost.Hoststatus.output">
                                <div class="cropText"
                                     ng-bind-html="notOkHost.Hoststatus.outputHtml | trustAsHtml"></div>
                            </div>
                        </div>
                        <div class="row padding-top-10" ng-show="summaryState.NotOkServices.length > 0">
                            <div class="col-lg-4">
                                <?php echo __('Service'); ?>
                            </div>
                            <div class="col-lg-3 no-padding">
                                <?php echo __('State'); ?>
                            </div>
                            <div class="col-lg-4">
                                <?php echo __('Output'); ?>
                            </div>
                        </div>
                        <div class="row padding-top-5" ng-repeat="notOkService in summaryState.NotOkServices">
                            <div class="col-lg-4 cropText"
                                 title="{{notOkService.Service.hostname}}/{{notOkService.Service.hostname}}">
                                <a ui-sref="ServicesBrowser({hostuuid: notOkService.Service.hostname, serviceuuid: notOkService.Service.service_description})">
                                    {{notOkService.Service.host_mapping.display_name}}/{{notOkService.Service.service_mapping.display_name}}
                                </a>
                            </div>
                            <div ng-show="notOkService.Servicestatus.isInMonitoring"
                                 class="col-lg-3 text-center txt-color-white text-capitalize bg-{{(notOkService.Servicestatus.isHardstate)?notOkService.Servicestatus.humanState:notOkService.Servicestatus.humanState+'-soft'}}">
                                {{notOkService.Servicestatus.humanState}}
                                <i ng-show="notOkService.Servicestatus.problemHasBeenAcknowledged"
                                   class="fa fa-user"></i>
                                <i ng-show="notOkService.Servicestatus.scheduledDowntimeDepth > 0"
                                   class="fa fa-power-off"></i>
                            </div>
                            <div ng-hide="notOkService.Servicestatus.isInMonitoring"
                                 class="col-lg-3 text-center txt-color-white bg-primary">
                                <?php echo __('Not in monitoring'); ?>
                                <i class="fa fa-eye-slash"></i>
                            </div>
                            <div class="col-lg-4 cropText" title="notOkService.Servicestatus.output">
                                {{notOkService.Servicestatus.output}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </article>
    </section>
</div>
