<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>

<img ng-src="/map_module/img/backgrounds/{{map.background}}" ng-if="map.background"/>
<div ng-repeat="item in map.mapitems"
     style="position:absolute; top: {{item.y}}px; left: {{item.x}}px;  z-index: {{item.z_index}};"
     ng-mouseenter="showSummaryStateDelayed(item, false)"
     ng-mouseleave="cancelTimer()">
    <a ng-href="{{ getHref(item) }}"
       ng-if="item.type !== 'hostgroup' && item.type !== 'servicegroup'">
        <map-item item="item" refresh-interval="refreshInterval"></map-item>
    </a>
    <!-- disable links for host and service groups -->
    <map-item item="item"
              ng-if="item.type === 'hostgroup' || item.type === 'servicegroup'"
              ng-mouseenter="showSummaryStateDelayed(item, false)"
              ng-mouseleave="cancelTimer()">
              refresh-interval="refreshInterval"></map-item>
</div>

<div ng-repeat="textItem in map.maptexts"
     style="position:absolute; top: {{textItem.y}}px; left: {{textItem.x}}px;  z-index: {{textItem.z_index}};">
    <map-text item="textItem"></map-text>
</div>

<div ng-repeat="lineItem in map.maplines"
     style="position: absolute; top: {{lineItem.startY}}px; left: {{lineItem.startX}}px;">
    <a ng-if="lineItem.type !== 'hostgroup' && lineItem.type !== 'servicegroup' && lineItem.type !== 'stateless'"
       ng-href="{{ getHref(lineItem) }}"
       ng-mouseenter="showSummaryStateDelayed(lineItem, false)"
       ng-mouseleave="cancelTimer()">
        <map-line item="lineItem" refresh-interval="refreshInterval"></map-line>
    </a>
    <!-- disable links for host and service groups and stateless lines -->
    <map-line
            ng-if="lineItem.type === 'hostgroup' || lineItem.type === 'servicegroup' || lineItem.type === 'stateless'"
            ng-mouseenter="showSummaryStateDelayed(lineItem, false)"
            ng-mouseleave="cancelTimer()"
            item="lineItem" refresh-interval="0"></map-line>

</div>

<div ng-repeat="iconItem in map.mapicons"
     style="position:absolute; top: {{iconItem.y}}px; left: {{iconItem.x}}px;  z-index: {{iconItem.z_index}};">
    <map-icon item="iconItem"></map-icon>
</div>

<div ng-repeat="gadgetItem in map.mapgadgets"
     style="position:absolute; top: {{gadgetItem.y}}px; left: {{gadgetItem.x}}px;  z-index: {{gadgetItem.z_index}};">
    <a ng-href="{{ getHref(gadgetItem) }}">
        <graph-item item="gadgetItem" ng-if="gadgetItem.gadget === 'RRDGraph'"
                    ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                    ng-mouseleave="cancelTimer()"
                    refresh-interval="refreshInterval"></graph-item>

        <perfdata-text-item item="gadgetItem" ng-if="gadgetItem.gadget === 'Text'"
                            ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                            ng-mouseleave="cancelTimer()"
                            refresh-interval="refreshInterval"></perfdata-text-item>
        <tacho-item item="gadgetItem" ng-if="gadgetItem.gadget === 'Tacho'"
                    ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                    ng-mouseleave="cancelTimer()"
                    refresh-interval="refreshInterval"></tacho-item>

        <cylinder-item item="gadgetItem" ng-if="gadgetItem.gadget === 'Cylinder'"
                       ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                       ng-mouseleave="cancelTimer()"
                       refresh-interval="refreshInterval"></cylinder-item>

        <trafficlight-item item="gadgetItem"
                           ng-if="gadgetItem.gadget === 'TrafficLight'"
                           ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                           ng-mouseleave="cancelTimer()"
                           refresh-interval="refreshInterval"></trafficlight-item>

        <temperature-item item="gadgetItem"
                          ng-if="gadgetItem.gadget === 'Temperature'"
                          ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                          ng-mouseleave="cancelTimer()"
                          refresh-interval="refreshInterval"></temperature-item>

        <service-output-item item="gadgetItem"
                             ng-if="gadgetItem.gadget === 'ServiceOutput'"
                             ng-mouseenter="showSummaryStateDelayed(gadgetItem, false)"
                             ng-mouseleave="cancelTimer()"
                             refresh-interval="refreshInterval"></service-output-item>
    </a>
</div>

<div ng-repeat="item in map.mapsummaryitems"
     style="position:absolute; top: {{item.y}}px; left: {{item.x}}px;  z-index: {{item.z_index}};"
     ng-mouseenter="showSummaryStateDelayed(item, true)"
     ng-mouseleave="cancelTimer()">
    <a ng-href="{{ getHref(item) }}"
       ng-if="item.type !== 'hostgroup' && item.type !== 'servicegroup'">
        <map-summary-item item="item" details="details"
                          refresh-interval="refreshInterval"></map-summary-item>
    </a>
    <!-- disable links for host and service groups -->
    <map-summary-item item="item" details="details"
                      ng-if="item.type === 'hostgroup' || item.type === 'servicegroup'"
                      ng-mouseenter="showSummaryStateDelayed(item, true)"
                      ng-mouseleave="cancelTimer()"
                      refresh-interval="refreshInterval"></map-summary-item>

</div>

<map-summary></map-summary>

<div id="graph_data_tooltip"></div>
