<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Map Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="MapsIndex">
            <i class="fa fa-retweet"></i> <?php echo __('Rotations'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-list"></i> <?php echo __('Overview'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Rotations'); ?>
                    <span class="fw-300"><i><?php echo __('overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-sitemap"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by Rotation name'); ?>"
                                                   ng-model="filter.rotation.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by Rotation Interval'); ?>"
                                                   ng-model="filter.rotation.interval"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort" ng-click="orderBy('Rotations.name')">
                                    <i class="fa" ng-class="getSortClass('Rotations.name')"></i>
                                    <?php echo __('Rotation name'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Rotations.interval')">
                                    <i class="fa" ng-class="getSortClass('Rotations.interval')"></i>
                                    <?php echo __('Rotation interval'); ?>
                                </th>
                                <th class="no-sort text-center" style="width:60px;">
                                    <i class="fa fa-eye"></i>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="rotation in rotations">
                                <td>
                                    <?php if ($this->Acl->hasPermission('view', 'Mapeditors', 'MapModule')): ?>
                                        <a ui-sref="MapeditorsView({id: rotation.first_id, rotation: rotation.ids, interval: rotation.interval})">
                                            {{ rotation.name }}
                                        </a>
                                    <?php else: ?>
                                        {{ rotation.name }}
                                    <?php endif; ?>
                                </td>
                                <td>
                                    {{ rotation.interval }}
                                </td>
                                <td>
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('view', 'Mapeditors', 'MapModule')): ?>
                                            <a ui-sref="MapeditorsView({id: rotation.first_id, rotation: rotation.ids, interval: rotation.interval})"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fa fa-eye"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default disabled btn-lower-padding">
                                                <i class="fa fa-eye"></i></a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('view', 'Mapeditors', 'MapModule')): ?>
                                                <a ui-sref="MapeditorsView({id: rotation.first_id, rotation: rotation.ids, interval: rotation.interval})"
                                                   class="dropdown-item"
                                                   ng-if="rotation.ids.length">
                                                    <i class="fa fa-eye"></i>
                                                    <?php echo __('View'); ?>
                                                </a>
                                                <a ui-sref="MapeditorsView({id: rotation.first_id, rotation: rotation.ids, interval: rotation.interval, fullscreen: 'true'})"
                                                   class="dropdown-item"
                                                   ng-if="rotation.ids.length">
                                                    <i class="fa fa-expand"></i>
                                                    <?php echo __('View in fullscreen'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="rotations.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
