<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Lib\Traits;

use Cake\ORM\Query;
use itnovum\openITCOCKPIT\Database\Cake4Paginator;
use itnovum\openITCOCKPIT\Database\ScrollIndex;

/**
 * Trait PaginationAndScrollIndexTrait
 * @package App\Lib\Traits
 */
trait PaginationAndScrollIndexTrait {

    /**
     * @param Query $query
     * @param Cake4Paginator $Cake4Paginator
     * @return array
     */
    public function paginateCake4(Query $query, Cake4Paginator $Cake4Paginator) {
        $Cake4Paginator->setCountResult($query->count());

        $query->offset($Cake4Paginator->getOffset());
        $query->limit($Cake4Paginator->getLimit());
        $result = $this->emptyArrayIfNull($query->toArray());
        $Cake4Paginator->setCurrent(sizeof($result));
        $Cake4Paginator->paginate();
        return $result;
    }

    /**
     * @param array|null $result
     * @return array
     */
    public function emptyArrayIfNull($result) {
        if ($result === null) {
            return [];
        }

        return $result;
    }

    /**
     * @param Query $query
     * @param ScrollIndex $ScrollIndex
     * @return array
     */
    public function scrollCake4(Query $query, ScrollIndex $ScrollIndex) {
        $query->offset($ScrollIndex->getOffset());
        $query->limit($ScrollIndex->getLimit());

        $query->all();
        $result = $query->toArray();
        if ($result === null) {
            $result = [];
        }
        $ScrollIndex->determineHasNextPage($result);
        $ScrollIndex->scroll();
        return $result;
    }

}
