<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Table;

use App\Filter\HostStatehistoryFilter;
use App\Lib\Traits\PaginationAndScrollIndexTrait;
use App\Model\Entity\HostStatehistory;
use Cake\Datasource\EntityInterface;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;
use itnovum\openITCOCKPIT\Database\PaginateOMat;

/**
 * HostStatehistory Model
 *
 * @method HostStatehistory get($primaryKey, $options = [])
 * @method HostStatehistory newEntity($data = null, array $options = [])
 * @method HostStatehistory[] newEntities(array $data, array $options = [])
 * @method HostStatehistory|bool save(EntityInterface $entity, $options = [])
 * @method HostStatehistory patchEntity(EntityInterface $entity, array $data, array $options = [])
 * @method HostStatehistory[] patchEntities($entities, array $data, array $options = [])
 * @method HostStatehistory findOrCreate($search, callable $callback = null, $options = [])
 */
class HostStatehistoryTable extends Table {
    use PaginationAndScrollIndexTrait;

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void {
        parent::initialize($config);

        $this->setTable('statusengine_host_statehistory');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator {
        //Readonly table
        return $validator;
    }

    /**
     * Returns a rules checker object that will be used for validating
     * application integrity.
     *
     * @param \Cake\ORM\RulesChecker $rules The rules object to be modified.
     * @return \Cake\ORM\RulesChecker
     */
    public function buildRules(RulesChecker $rules): RulesChecker {
        //Readonly table
        return $rules;
    }

    public function getHostStateHistory(HostStatehistoryFilter $HostStatehistoryFilter, ?PaginateOMat $PaginateOMat = null) {
        $query = $this->find()
            ->where($HostStatehistoryFilter->indexFilter())
            ->order($HostStatehistoryFilter->getOrderForPaginator('HostStatehistory.state_time', 'desc'));

        if ($PaginateOMat === null) {
            //Just execute query
            $result = $query->toArray();
        } else {
            if ($PaginateOMat->useScroll()) {
                $result = $this->scrollCake4($query, $PaginateOMat->getHandler());
            } else {
                $result = $this->paginateCake4($query, $PaginateOMat->getHandler());
            }
        }

        return $result;
    }
}
