<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
            <a ui-sref="HostsIndex">
                <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
            <a ui-sref="HostsBrowser({uuid: hoststatus.hostname})">
                <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
            </a>
        <?php else: ?>
            <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <i class="fa fa-user"></i> <?php echo __('Acknowledgement history'); ?>
    </li>
</ol>

<hostmenu hoststatus="hoststatus" showbackbutton="true" ng-if="hoststatus"></hostmenu>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Host'); ?>
                    <span class="fw-300"><i><?php echo __('acknowledgement history'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?php echo __('From'); ?></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   style="padding:0.5rem 0.875rem;"
                                                   placeholder="<?php echo __('From date'); ?>"
                                                   ng-model="filter.from"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by comment'); ?>"
                                                   ng-model="filter.AcknowledgementHosts.comment"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?php echo __('To'); ?></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   style="padding:0.5rem 0.875rem;"
                                                   placeholder="<?php echo __('To date'); ?>"
                                                   ng-model="filter.to"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-user"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by author'); ?>"
                                                   ng-model="filter.AcknowledgementHosts.author"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('States'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterDown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.AcknowledgementHosts.state.down"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-down"
                                                       for="statusFilterDown"><?php echo __('Down'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnreachable"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.AcknowledgementHosts.state.unreachable"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unreachable"
                                                       for="statusFilterUnreachable"><?php echo __('Unreachable'); ?></label>
                                            </div>

                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort" ng-click="orderBy('AcknowledgementHosts.state')">
                                    <i class="fa" ng-class="getSortClass('AcknowledgementHosts.state')"></i>
                                    <?php echo __('State'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('AcknowledgementHosts.entry_time')">
                                    <i class="fa" ng-class="getSortClass('AcknowledgementHosts.entry_time')"></i>
                                    <?php echo __('Date'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('AcknowledgementHosts.author_name')">
                                    <i class="fa" ng-class="getSortClass('AcknowledgementHosts.author_name')"></i>
                                    <?php echo __('Author'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('AcknowledgementHosts.comment_data')">
                                    <i class="fa" ng-class="getSortClass('AcknowledgementHosts.comment_data')"></i>
                                    <?php echo __('Comment'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('AcknowledgementHosts.is_sticky')">
                                    <i class="fa" ng-class="getSortClass('AcknowledgementHosts.is_sticky')"></i>
                                    <?php echo __('Sticky'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>

                            <tr ng-repeat="Acknowledgement in acknowledgements">

                                <td class="text-center">
                                    <hoststatusicon state="Acknowledgement.AcknowledgedHost.state"></hoststatusicon>
                                </td>
                                <td>
                                    {{ Acknowledgement.AcknowledgedHost.entry_time }}
                                </td>
                                <td>
                                    {{ Acknowledgement.AcknowledgedHost.author_name }}
                                </td>
                                <td ng-bind-html="Acknowledgement.AcknowledgedHost.comment_data | trustAsHtml">

                                </td>
                                <td class="text-center">
                                        <span ng-show="Acknowledgement.AcknowledgedHost.is_sticky">
                                            <?php echo __('True'); ?>
                                        </span>

                                    <span ng-show="!Acknowledgement.AcknowledgedHost.is_sticky">
                                            <?php echo __('False'); ?>
                                        </span>

                                </td>
                            </tr>

                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="acknowledgements.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
