<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fas fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="AgentconnectorsPush">
            <i class="fa fa-user-secret"></i> <?php echo __('openITCOCKPIT Agent'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-wand-magic-sparkles"></i> <?php echo __('Overview'); ?>
    </li>
</ol>

<massdelete
    help="<?= __('By deleting, the corresponding openITCOCKPIT Agent is not able to send data to the openITCOCKPIT server anymore.'); ?>"></massdelete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Agents overview'); ?>
                    <span class="fw-300"><i><?php echo __('Push mode'); ?></i></span>
                </h2>

                <div class="panel-toolbar">
                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean" role="tablist">
                        <?php if ($this->Acl->hasPermission('overview', 'agentconnector')): ?>
                            <li class="nav-item">
                                <a class="nav-link" data-toggle="tab" ui-sref="AgentconnectorsPull" role="tab">
                                    <i class="fas fa-download"></i>&nbsp;
                                    <?php echo __('Pull'); ?>
                                </a>
                            </li>


                        <?php endif; ?>
                        <?php if ($this->Acl->hasPermission('overview', 'agentconnector')): ?>
                            <li class="nav-item">
                                <a class="nav-link active" data-toggle="tab" ui-sref="AgentconnectorsPush" role="tab">
                                    <i class="fas fa-upload"></i>&nbsp;
                                    <?php echo __('Push'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                    </ul>
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-desktop"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by host name'); ?>"
                                                   ng-model="filter.HostMapping.display_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-xs-12 col-md-6">
                                    <fieldset>
                                        <h5><?php echo __('Host assignments'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="FilterAssigned"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.host_assignment"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="FilterAssigned"><?php echo __('Host assigned'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="FilterNotAssigned"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.no_host_assignment"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="FilterNotAssigned"><?php echo __('Agents witout host assignment'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter end -->
                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort sorting_disabled width-15">
                                    <i class="fa fa-check-square"></i>
                                </th>
                                <th class="no-sort" ng-click="orderBy('HostMapping.display_name')">
                                    <i class="fa" ng-class="getSortClass('HostMapping.display_name')"></i>
                                    <?php echo __('Assigned host'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('PushAgents.uuid')">
                                    <i class="fa" ng-class="getSortClass('PushAgents.uuid')"></i>
                                    <?php echo __('Agent UUID'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('PushAgents.hostname')">
                                    <i class="fa" ng-class="getSortClass('PushAgents.hostname')"></i>
                                    <?php echo __('Agent Hostname'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('PushAgents.ipaddress')">
                                    <i class="fa" ng-class="getSortClass('PushAgents.ipaddress')"></i>
                                    <?php echo __('Agent IP address'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('PushAgents.hostname')">
                                    <i class="fa" ng-class="getSortClass('PushAgents.hostname')"></i>
                                    <?php echo __('Remote address'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('PushAgents.last_update')">
                                    <i class="fa" ng-class="getSortClass('PushAgents.last_update')"></i>
                                    <?php echo __('Last update'); ?>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-cog"></i>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="agent in agents">
                                <td class="text-center" class="width-15">
                                    <?php if ($this->Acl->hasPermission('delete', 'agentconnector')): ?>
                                        <input type="checkbox"
                                               ng-model="massChange[agent.id]">
                                    <?php endif; ?>
                                </td>
                                <td>
                                    <span ng-show="agent.HostMapping.display_name">
                                        <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                            <a ui-sref="HostsBrowser({uuid:agent.HostMapping.uuid})">
                                                {{ agent.HostMapping.display_name}}
                                            </a>
                                        <?php else: ?>
                                            {{ agent.HostMapping.display_name}}
                                        <?php endif; ?>
                                    </span>
                                    <span ng-show="agent.HostMapping.display_name === null"
                                          class="italic text-secondary">
                                        <?= __('No host assignment defined'); ?>
                                    </span>
                                </td>
                                <td>
                                    {{ agent.uuid}}
                                </td>
                                <td>
                                    {{ agent.hostname}}
                                </td>
                                <td>
                                    {{ agent.ipaddress}}
                                </td>
                                <td>
                                    {{agent.http_x_forwarded_for ? agent.http_x_forwarded_for : agent.remote_address}}
                                </td>
                                <td>
                                    {{ agent.last_update}}
                                </td>
                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <a href="javascript:void(0);"
                                           class="btn btn-default btn-lower-padding disabled">
                                            <i class="fa fa-cog"></i></a>

                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('showOutput', 'agentconnector')): ?>
                                                <a ui-sref="AgentconnectorsShowOutput({mode: 'push',id: agent.id})"
                                                   class="dropdown-item">
                                                    <i class="fab fa-js"></i>
                                                    <?php echo __('Show received data'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('delete', 'agentconnector')): ?>
                                                <div class="dropdown-divider"></div>
                                                <a href="javascript:void(0);"
                                                   class="txt-color-red dropdown-item"
                                                   ng-click="confirmDelete(getObjectForDelete(agent))">
                                                    <i class="fa fa-trash"></i> <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="agents.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <div class="col-xs-12 col-md-2 text-muted text-center">
                                <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="selectAll()" class="pointer">
                                    <i class="fas fa-lg fa-check-square"></i>
                                    <?php echo __('Select all'); ?>
                                </span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="undoSelection()" class="pointer">
                                    <i class="fas fa-lg fa-square"></i>
                                    <?php echo __('Undo selection'); ?>
                                </span>
                            </div>
                            <?php if ($this->Acl->hasPermission('delete', 'agentconnector')): ?>
                                <div class="col-xs-12 col-md-4 txt-color-red">
                                    <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Delete selected'); ?>
                                    </span>
                                </div>
                            <?php endif; ?>
                        </div>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
