<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
            <a ui-sref="HostsIndex">
                <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
    </li>
</ol>

<hostmenu hoststatus="hoststatus" showbackbutton="false" ng-if="hoststatus"></hostmenu>

<div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-host callback="showFlashMsg"></reschedule-host>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <host-downtime callback="showFlashMsg"></host-downtime>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-host callback="showFlashMsg"></acknowledge-host>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
    <submit-host-result max-check-attempts="{{hoststatus.max_check_attempts}}"
                        callback="showFlashMsg"></submit-host-result>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
    <enable-host-flap-detection callback="showFlashMsg"></enable-host-flap-detection>
    <disable-host-flap-detection callback="showFlashMsg"></disable-host-flap-detection>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
    <mass-delete-host-downtimes delete-url="/externalcommands/cancel_downtime"
                                callback="showFlashMsg"></mass-delete-host-downtimes>
<?php endif; ?>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Host:'); ?>
                    <span class="fw-300">
                        <i>{{ hoststatus.host_mapping.display_name }}</i>
                    </span>
                </h2>

                <div class="panel-toolbar">

                    <ul class="nav nav-pills border-bottom-0" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link disabled" data-toggle="tab" href="javascript:void(0);" role="tab">
                                UUID: {{ hoststatus.hostname }}
                            </a>
                        </li>
                    </ul>

                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean flex-column flex-sm-row" role="tablist">
                        <li class="nav-item pointer">
                            <a class="nav-link active" data-toggle="tab" ng-click="selectedTab = 'tab1'"
                               role="tab">
                                <i class="fa fa-info">&nbsp;</i> <?php echo __('Status information'); ?>
                            </a>
                        </li>
                    </ul>
                </div>
            </div>

            <div class="panel-container show">
                <div class="panel-content">
                    <!-- -->
                    <!-- Status information start -->
                    <div ng-show="selectedTab == 'tab1'" class="tab-pane">
                        <!-- status overview for small resolutions -->
                        <div class="d-sm-none"
                             ng-class="{'browser-state-green': stateIsUp(), 'browser-state-red': stateIsDown(), 'browser-state-gray': stateIsUnreachable(), 'browser-state-blue': stateIsNotInMonitoring()}"
                             ng-if="hoststatus">
                            <div class="row">
                                <div class="col-6 padding-left-25">
                                    <?php echo __('State'); ?>
                                </div>
                                <div class="col-6">
                                    {{ hoststatus.current_state | hostStatusName }}
                                </div>
                            </div>

                            <div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State since'); ?>
                                    </div>
                                    <div class="col-6">
                                        {{ hoststatus.last_state_change_for_humans }}
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('Last check'); ?>
                                    </div>
                                    <div class="col-6">
                                        {{ hoststatus.last_check_in_words }}
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('Next check'); ?>
                                    </div>
                                    <div class="col-6">
                                        <span
                                                ng-if="hoststatus.active_checks_enabled">
                                            {{hoststatus.next_check_in_words }}
                                        </span>
                                        <span
                                                ng-if="hoststatus.active_checks_enabled === false">
                                            <?php echo __('n/a'); ?>
                                        </span>
                                    </div>
                                </div>
                                <div class="row" ng-show="hoststatus.isHardstate">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State type'); ?>
                                    </div>
                                    <div class="col-6">
                                        <?php echo __('Hard state'); ?>
                                        ({{hoststatus.current_check_attempt}}/{{hoststatus.max_check_attempts}})
                                    </div>
                                </div>
                                <div class="row" ng-show="!hoststatus.is_hardstate">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State type'); ?>
                                    </div>
                                    <div class="col-6">
                                        <?php echo __('Soft state'); ?>
                                        ({{hoststatus.current_check_attempt}}/{{hoststatus.max_check_attempts}})
                                    </div>
                                </div>

                                <div class="row justify-content-center padding-top-10 padding-bottom-10">
                                    <div class="btn-group" role="group" aria-label="Basic example">
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="rescheduleHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="hostDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-power-off"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-show="hoststatus.current_state > 0"
                                                    ng-click="acknowledgeHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="submitHostResult(getObjectsForExternalCommand())">
                                                <i class="fa fa-download"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="enableHostFlapDetection(getObjectsForExternalCommand())"
                                                    ng-show="!hoststatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                            </button>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="disableHostFlapDetection(getObjectsForExternalCommand())"
                                                    ng-show="hoststatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                            </button>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div
                                    class="col-xs-12 col-sm-6 col-md-7 col-lg-9 padding-bottom-10 padding-left-10 padding-right-10">

                                <div class="row" ng-show="mergedHost.disabled">
                                    <div
                                            class="col-lg-12 bg-warning browser-border margin-bottom-10 margin-left-10 padding-5">
                                        <h4>
                                            <i class="fa fa-plug"></i>
                                            <?php echo __('This host is currently disabled!'); ?>
                                        </h4>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-lg-12">
                                        <h3 class="margin-top-5"><?php echo __('Status overview'); ?></h3>
                                    </div>
                                </div>

                                <div class="row" ng-show="hoststatus.scheduled_downtime_depth > 0">
                                    <div class="col-lg-12 margin-bottom-10">
                                        <div class="browser-border padding-10" style="width: 100%;">

                                            <div class="row">
                                                <div class="col-lg-12">
                                                    <div>
                                                        <h4 class="no-padding">
                                                            <i class="fa fa-power-off"></i>
                                                            <?php echo __('The host is currently in a planned maintenance period'); ?>
                                                        </h4>
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Downtime was set by'); ?>
                                                        <b>{{downtime.author_name}}</b>
                                                        <?php echo __('with an duration of'); ?>
                                                        <b>{{downtime.duration_for_humans}}</b>.
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <small>
                                                            <?php echo __('Start time:'); ?>
                                                            {{ downtime.scheduled_start_time }}
                                                            <?php echo __('End time:'); ?>
                                                            {{ downtime.scheduled_end_time }}
                                                        </small>
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Comment: '); ?>
                                                        {{downtime.comment_data}}
                                                    </div>
                                                </div>

                                                <div class="col-lg-12">
                                                    <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                                        <button
                                                                class="btn btn-xs btn-danger float-right"
                                                                ng-if="downtime.is_cancellable"
                                                                ng-click="confirmHostDowntimeDelete(getObjectsForDowntimeDelete())">
                                                            <i class="fa fa-trash"></i> <?php echo __('Cancel'); ?>
                                                        </button>
                                                    <?php endif; ?>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row" ng-show="hoststatus.problem_has_been_acknowledged">
                                    <div class="col-lg-12 margin-bottom-10">
                                        <div class="browser-border padding-10" style="width: 100%;">
                                            <div>
                                                <h4 class="no-padding">
                                                    <i class="far fa-user" ng-show="!acknowledgement.is_sticky"></i>
                                                    <i class="fas fa-user" ng-show="acknowledgement.is_sticky"></i>
                                                    <?php echo __('State of host is acknowledged'); ?>
                                                    <span ng-show="acknowledgement.is_sticky">
                                                        (<?php echo __('Sticky'); ?>)
                                                    </span>
                                                </h4>
                                            </div>
                                            <div class="padding-top-5">
                                                <?php echo __('Acknowledgement was set by'); ?>
                                                <b>{{acknowledgement.author_name}}</b>
                                                <?php echo __('at'); ?>
                                                {{acknowledgement.entry_time}}
                                            </div>
                                            <div class="padding-top-5">
                                                <?php echo __('Comment: '); ?>
                                                <div style="display:inline"
                                                     ng-bind-html="acknowledgement.comment_data_html | trustAsHtml"></div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row" ng-show="hoststatus.is_flapping">
                                    <div class="col-lg-12 margin-bottom-10">
                                        <div class="browser-border padding-10" style="width: 100%;">
                                            <div>
                                                <h4 class="no-padding txt-color-orangeDark">
                                                    <i class="fa fa-exclamation-triangle"></i>
                                                    <?php echo __('The state of this host is currently flapping!'); ?>
                                                </h4>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-xs-12 col-sm-12 col-md-9">
                                        <table class="table table-bordered">
                                            <tr>
                                                <td><?php echo __('Flap detection enabled'); ?></td>
                                                <td>
                                                    <span class="badge badge-danger"
                                                          ng-show="hoststatus.flap_detection_enabled">
                                                        <?php echo __('Yes'); ?>
                                                    </span>

                                                    <span class="badge badge-success"
                                                          ng-show="!hoststatus.flap_detection_enabled">
                                                        <?php echo __('No'); ?>
                                                    </span>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><?php echo __('Active checks enabled'); ?></td>
                                                <td ng-if="hoststatus">
                                                    <span class="badge badge-success"
                                                          ng-show="hoststatus.active_checks_enabled">
                                                        <?php echo __('On'); ?>
                                                    </span>
                                                    <span class="badge badge-danger"
                                                          ng-show="!hoststatus.active_checks_enabled">
                                                        <?php echo __('Off'); ?>
                                                    </span>
                                                </td>
                                            </tr>
                                            <tr ng-show="hoststatus.current_state > 0">
                                                <td>
                                                    <?php echo __('Last time'); ?>
                                                    <span class="badge badge-success" style="margin-right: 2px;">
                                                        <?php echo __('UP'); ?>
                                                    </span>
                                                </td>
                                                <td>
                                                    {{ hoststatus.last_time_up }}
                                                </td>
                                            </tr>

                                            <tr>
                                                <td><?php echo __('Output'); ?></td>
                                                <td>
                                                    <div
                                                            class="code-font {{ getColorOfState(hoststatus.current_state) }}"
                                                            ng-class="hostStatusTextClass"
                                                            ng-bind-html="hoststatus.output_html | trustAsHtml">
                                                        {{ hoststatus.output }}
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>
                                    </div> <!-- status table -->
                                    <div class="col-xs-12 col-sm-12 col-md-3">
                                        <table class="table table-bordered">
                                            <tr>
                                                <td><?php echo __('Check period'); ?></td>
                                                <td>
                                                    {{ hoststatus.timeperiod_mapping.display_name }}
                                                </td>
                                            </tr>

                                            <tr>
                                                <td><?php echo __('Check interval'); ?></td>
                                                <td>
                                                    <span ng-show="hoststatus.active_checks_enabled">
                                                        {{ hoststatus.normal_check_interval_for_humans }}
                                                    </span>
                                                    <span ng-show="!hoststatus.active_checks_enabled">
                                                        <?php echo __('n/a due to passive check'); ?>
                                                    </span>
                                                </td>
                                            </tr>

                                            <tr>
                                                <td><?php echo __('Retry interval'); ?></td>
                                                <td>
                                                    <span ng-show="hoststatus.active_checks_enabled">
                                                        {{ hoststatus.retry_check_interval_for_humans }}
                                                    </span>
                                                    <span ng-show="!hoststatus.active_checks_enabled">
                                                        <?php echo __('n/a due to passive check'); ?>
                                                    </span>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>

                                <div class="row padding-bottom-10" ng-show="hoststatus.long_output_html">
                                    <div class="col-12">
                                        <h5 class="margin-top-5"><?= __('Long output') ?></h5>
                                    </div>
                                    <div class="col-12">
                                        <div class="card bg-light">
                                            <div class="card-body ng-binding"
                                                 ng-bind-html="hoststatus.long_output_html | trustAsHtml"></div>
                                        </div>
                                    </div>
                                </div>

                            </div>
                            <div class="col-sm-6 col-md-5 col-lg-3 no-padding d-none d-sm-block"
                                 ng-class="{'browser-state-green': stateIsUp(), 'browser-state-red': stateIsDown(), 'browser-state-gray': stateIsUnreachable(), 'browser-state-blue': stateIsNotInMonitoring()}"
                                 ng-if="hoststatus">
                                <!-- status box -->
                                <div class="text-center txt-color-white">
                                    <h1 class="font-size-50">
                                        {{ hoststatus.current_state | hostStatusName }}
                                    </h1>
                                </div>
                                <div>
                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('State since'); ?></div>
                                        <h3 class="margin-top-0" title="{{hoststatus.last_state_change}}">
                                            {{ hoststatus.last_state_change_for_humans }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('Last check'); ?></div>
                                        <h3 class="margin-top-0" title="{{hoststatus.last_check}}">
                                            {{ hoststatus.last_check_in_words }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('Next check'); ?></div>
                                        <h3 title="{{hoststatus.next_check}}">
                                            {{ hoststatus.next_check_in_words }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('State type'); ?></div>
                                        <h3 class="margin-top-0" ng-show="hoststatus.is_hardstate">
                                            <?php echo __('Hard state'); ?>
                                            ({{hoststatus.current_check_attempt}}/{{hoststatus.max_check_attempts}})
                                        </h3>

                                        <h3 class="margin-top-0" ng-show="!hoststatus.is_hardstate">
                                            <?php echo __('Soft state'); ?>
                                            ({{hoststatus.current_check_attempt}}/{{hoststatus.max_check_attempts}})
                                        </h3>
                                    </div>

                                    <div>
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <div class="browser-action"
                                                 ng-click="rescheduleHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i>
                                                <?php echo __('Reset check time '); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="hostDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-power-off"></i>
                                                <?php echo __('Schedule maintenance'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-show="hoststatus.current_state > 0"
                                                 ng-click="acknowledgeHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i>
                                                <?php echo __('Acknowledge host status'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="submitHostResult(getObjectsForExternalCommand())">
                                                <i class="fa fa-download"></i>
                                                <?php echo __('Passive transfer check result'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="enableHostFlapDetection(getObjectsForExternalCommand())"
                                                 ng-show="!hoststatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                                <?php echo __('Enable flap detection'); ?>
                                            </div>

                                            <div class="browser-action margin-top-10"
                                                 ng-click="disableHostFlapDetection(getObjectsForExternalCommand())"
                                                 ng-show="hoststatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                                <?php echo __('Disable flap detection'); ?>
                                            </div>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Status information end -->
                </div>
            </div>
        </div>
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <div>
                <div class="panel-container show">
                    <div class="panel-content">
                        <div ng-show="selectedTab == 'tab1'" class="tab-pane">
                            <div class="row">
                                <div class="col-xl-12">
                                    <div id="widget-container" class="panel">
                                        <div class="panel-hdr">
                                            <h2>
                                                <strong><?php echo __('Services'); ?></strong>&nbsp;
                                                <i><?php echo __('Overview'); ?></i>
                                            </h2>

                                            <div class="panel-toolbar">
                                                <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                                                    <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                                                </button>
                                                <button class="btn btn-xs btn-primary shadow-0"
                                                        ng-click="triggerFilter()">
                                                    <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                                                </button>
                                            </div>
                                        </div>

                                        <div class="panel-container show">
                                            <div class="panel-content">
                                                <!-- Start Filter -->
                                                <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                                                    <div class="card-header">
                                                        <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                                                    </div>
                                                    <div class="card-body">
                                                        <div class="row">
                                                            <div class="col-xs-12 col-md-6 margin-bottom-10">
                                                                <div class="form-group">
                                                                    <div class="input-group">
                                                                        <div class="input-group-prepend">
                                                                            <span class="input-group-text"><i
                                                                                        class="fas fa-cogs"></i></span>
                                                                        </div>
                                                                        <input type="text"
                                                                               class="form-control form-control-sm"
                                                                               placeholder="<?php echo __('Filter by service name'); ?>"
                                                                               ng-model="filter_service_name"
                                                                               ng-model-options="{debounce: 500}">
                                                                    </div>
                                                                </div>
                                                            </div>

                                                            <div class="col-xs-12 col-md-6 margin-bottom-10">
                                                                <div class="form-group">
                                                                    <div class="input-group">
                                                                        <div class="input-group-prepend">
                                                                            <span class="input-group-text"><i
                                                                                        class="fas fa-filter"></i></span>
                                                                        </div>
                                                                        <input type="text"
                                                                               class="form-control form-control-sm"
                                                                               placeholder="<?php echo __('Filter by output'); ?>"
                                                                               ng-model="filter_output"
                                                                               ng-model-options="{debounce: 500}">
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="row">
                                                            <div class="col-xs-12 col-lg-3">
                                                                <fieldset>
                                                                    <h5><?php echo __('Service status'); ?></h5>
                                                                    <div class="form-group">
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="statusFilterOk"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="stateOk"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label
                                                                                    class="custom-control-label custom-control-label-ok"
                                                                                    for="statusFilterOk"><?php echo __('Ok'); ?></label>
                                                                        </div>
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="statusFilterWarning"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="stateWarning"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label
                                                                                    class="custom-control-label custom-control-label-warning"
                                                                                    for="statusFilterWarning"><?php echo __('Warning'); ?></label>
                                                                        </div>
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="statusFilterCritical"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="stateCritical"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label
                                                                                    class="custom-control-label custom-control-label-critical"
                                                                                    for="statusFilterCritical"><?php echo __('Critical'); ?></label>
                                                                        </div>
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="statusFilterUnknown"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="stateUnknown"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label
                                                                                    class="custom-control-label custom-control-label-unknown"
                                                                                    for="statusFilterUnknown"><?php echo __('Unknown'); ?></label>
                                                                        </div>
                                                                    </div>
                                                                </fieldset>
                                                            </div>

                                                            <div class="col-xs-12 col-lg-3">
                                                                <fieldset>
                                                                    <h5><?php echo __('Acknowledgements'); ?></h5>
                                                                    <div class="form-group">
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="ackFilterAck"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="filter.Servicestatus.acknowledged"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label class="custom-control-label"
                                                                                   for="ackFilterAck"><?php echo __('Acknowledge'); ?></label>
                                                                        </div>

                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="ackFilterNotAck"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="filter.Servicestatus.not_acknowledged"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label class="custom-control-label"
                                                                                   for="ackFilterNotAck"><?php echo __('Not acknowledged'); ?></label>
                                                                        </div>
                                                                    </div>
                                                                </fieldset>
                                                            </div>

                                                            <div class="col-xs-12 col-lg-3">
                                                                <fieldset>
                                                                    <h5><?php echo __('Downtimes'); ?></h5>
                                                                    <div class="form-group smart-form">
                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="downtimwFilterInDowntime"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="filter.Servicestatus.in_downtime"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label class="custom-control-label"
                                                                                   for="downtimwFilterInDowntime"><?php echo __('In downtime'); ?></label>
                                                                        </div>

                                                                        <div class="custom-control custom-checkbox">
                                                                            <input type="checkbox"
                                                                                   id="downtimwFilterNotInDowntime"
                                                                                   class="custom-control-input"
                                                                                   name="checkbox"
                                                                                   checked="checked"
                                                                                   ng-model="filter.Servicestatus.not_in_downtime"
                                                                                   ng-model-options="{debounce: 500}">
                                                                            <label class="custom-control-label"
                                                                                   for="downtimwFilterNotInDowntime"><?php echo __('Not in downtime'); ?></label>
                                                                        </div>
                                                                    </div>
                                                                </fieldset>
                                                            </div>
                                                        </div>
                                                        <div class="float-right">
                                                            <button type="button" ng-click="resetFilter()"
                                                                    class="btn btn-xs btn-danger">
                                                                <?php echo __('Reset Filter'); ?>
                                                            </button>
                                                        </div>
                                                    </div>
                                                </div>
                                                <!-- End Filter -->

                                                <div class="frame-wrap">
                                                    <table
                                                            class="table table-striped m-0 table-bordered table-hover table-sm"
                                                            role="grid">
                                                        <thead>
                                                        <tr>
                                                            <th ng-click="orderBy('Servicestatus.current_state')"
                                                                class="width-120 cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.current_state')"></i>
                                                                <?php echo __('Service status'); ?>
                                                            </th>

                                                            <th class="no-sort text-center">
                                                                <i class="fa fa-user"
                                                                   title="<?php echo __('is acknowledged'); ?>"></i>
                                                            </th>

                                                            <th class="no-sort text-center">
                                                                <i class="fa fa-power-off"
                                                                   title="<?php echo __('is in downtime'); ?>"></i>
                                                            </th>

                                                            <th ng-click="orderBy('Servicestatus.active_checks_enabled')"
                                                                class="width-40 cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.active_checks_enabled')"></i>
                                                                <strong
                                                                        title="<?php echo __('Passively transferred service'); ?>">
                                                                    <?php echo __('P'); ?>
                                                                </strong>
                                                            </th>

                                                            <th class="no-sort text-center">
                                                                <i class="fa fa fa-area-chart"
                                                                   title="<?php echo __('Grapher'); ?>"></i>
                                                            </th>

                                                            <th ng-click="orderBy('ServiceMapping.display_name')"
                                                                class="cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('ServiceMapping.display_name')"></i>
                                                                <?php echo __('Service name'); ?>
                                                            </th>

                                                            <th ng-click="orderBy('Servicestatus.last_state_change')"
                                                                class="cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.last_state_change')"></i>
                                                                <?php echo __('State since'); ?>
                                                            </th>

                                                            <th ng-click="orderBy('Servicestatus.last_check')"
                                                                class="cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.last_check')"></i>
                                                                <?php echo __('Last check'); ?>
                                                            </th>

                                                            <th ng-click="orderBy('Servicestatus.next_check')"
                                                                class="cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.next_check')"></i>
                                                                <?php echo __('Next check'); ?>
                                                            </th>

                                                            <th ng-click="orderBy('Servicestatus.output')"
                                                                class="cursor-pointer">
                                                                <i class="fa"
                                                                   ng-class="getSortClass('Servicestatus.output')"></i>
                                                                <?php echo __('Output'); ?>
                                                            </th>
                                                        </tr>
                                                        </thead>
                                                        <tbody>
                                                        <tr ng-repeat="service in servicestatus">
                                                            <td class="text-center">
                                                                <servicestatusicon
                                                                        state="service.current_state"
                                                                        is-flapping="service.is_flapping"></servicestatusicon>
                                                            </td>

                                                            <td class="text-center">
                                                                <i class="far fa-user"
                                                                   ng-show="service.problem_has_been_acknowledged"
                                                                   ng-if="service.acknowledgement_type == 1"></i>

                                                                <i class="fas fa-user"
                                                                   ng-show="service.problem_has_been_acknowledged"
                                                                   ng-if="service.acknowledgement_type == 2"
                                                                   title="<?php echo __('Sticky Acknowledgedment'); ?>"></i>
                                                            </td>

                                                            <td class="text-center">
                                                                <i class="fa fa-power-off"
                                                                   ng-show="service.scheduled_downtime_depth > 0"></i>
                                                            </td>


                                                            <td class="text-center">
                                                                <strong
                                                                        title="<?php echo __('Passively transferred service'); ?>"
                                                                        ng-hide="service.active_checks_enabled">
                                                                    <?php echo __('P'); ?>
                                                                </strong>
                                                            </td>

                                                            <td class="text-center">
                                                                <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                                                    <a ui-sref="ServicesBrowser({hostuuid:service.hostname, serviceuuid:service.service_description})"
                                                                       class="txt-color-blueDark"
                                                                       ng-mouseenter="mouseenter($event, service.hostname, service.service_description)"
                                                                       ng-mouseleave="mouseleave()">
                                                                        <i class="fa fa-lg fa-area-chart">
                                                                        </i>
                                                                    </a>
                                                                <?php else: ?>
                                                                    <div ng-mouseenter="mouseenter($event, service.hostname, service.service_description)"
                                                                         ng-mouseleave="mouseleave()">
                                                                        <i class="fa fa-lg fa-area-chart">
                                                                        </i>
                                                                    </div>
                                                                <?php endif; ?>
                                                            </td>

                                                            <td>
                                                                <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                                                    <a ui-sref="ServicesBrowser({hostuuid:service.hostname, serviceuuid:service.service_description})">
                                                                        {{ service.service_mapping.display_name }}
                                                                    </a>
                                                                <?php else: ?>
                                                                    {{ service.service_mapping.display_name }}

                                                                <?php endif; ?>
                                                            </td>

                                                            <td>
                                                                {{ service.last_state_change }}
                                                            </td>

                                                            <td>
                                                                {{ service.last_check }}
                                                            </td>

                                                            <td>
                                                                <span ng-show="service.active_checks_enabled">
                                                                    {{ service.next_check }}
                                                                </span>
                                                            </td>

                                                            <td> {{ service.output }}</td>

                                                        </tr>

                                                        <tr ng-show="servicestatus.length == 0">
                                                            <td colspan="8" class="text-center txt-color-red">
                                                                <?php echo __('No results found'); ?>
                                                            </td>
                                                        </tr>

                                                        </tbody>
                                                    </table>
                                                    <scroll scroll="scroll" click-action="changepage"
                                                            ng-if="scroll"></scroll>
                                                    <paginator paging="paging" click-action="changepage"
                                                               ng-if="paging"></paginator>
                                                    <?php echo $this->element('paginator_or_scroll'); ?>

                                                    <popover-graph-directive></popover-graph-directive>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
