<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<div id="angularServiceStatusDetailsModal" class="modal" role="dialog">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">
                    <i class="fa fa-cogs"></i>
                    <?php echo __('Service status details'); ?>
                </h5>
                <div class="ml-auto">
                    <button class="btn btn-default btn-xs" ng-click="loadServiceDetails(servicestatus)">
                        <i class="fa fa-refresh" ng-class="{'fa-spin': isLoading}"></i>
                        <?php echo __('Refresh'); ?>
                    </button>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true"><i class="fa fa-times"></i></span>
                    </button>
                </div>
            </div>
            <div class="modal-body">
                <div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

                <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                    <mass-delete-service-downtimes delete-url="/externalcommands/cancel_downtime"
                                                   callback="showFlashMsg"></mass-delete-service-downtimes>
                <?php endif; ?>

                <div class="txt-color-white padding-10"
                     ng-class="{'browser-state-green': stateIsOk(), 'browser-state-yellow': stateIsWarning(), 'browser-state-red': stateIsCritical(), 'browser-state-gray': stateIsUnknown()}"
                     ng-if="servicestatus">

                    <div class="row">
                        <div class="col-xs-12 col-md-2">
                            <strong><?php echo __('Host'); ?></strong>
                        </div>
                        <div class="col-xs-12 col-md-10">
                            <strong>{{servicestatus.host_mapping.display_name}}</strong>
                        </div>
                    </div>


                    <div class="row">
                        <div class="col-xs-12 col-md-2">
                            <strong><?php echo __('Service'); ?></strong>
                        </div>
                        <div class="col-xs-12 col-md-10">
                            <strong>{{servicestatus.service_mapping.display_name}}</strong>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-xs-12 col-md-2">
                            <?php echo __('State'); ?>
                        </div>
                        <div class="col-xs-12 col-md-10">
                            {{ servicestatus.current_state | serviceStatusName }}
                        </div>
                    </div>

                    <div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('State since'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ servicestatus.last_state_change }}">
                                    {{ servicestatus.last_state_change_for_humans }}
                                </span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('Last check'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ servicestatus.last_check }}">
                                    {{ servicestatus.last_check_in_words }}
                                </span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __(' Next check'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ servicestatus.next_check }}">
                                    {{ servicestatus.next_check_in_words }}
                                </span>
                            </div>
                        </div>
                        <div class="row" ng-show="!servicestatus.is_hardstate">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('State type'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <?php echo __('Soft state'); ?>
                                ({{servicestatus.current_check_attempt}}/{{servicestatus.max_check_attempts}})
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('Output'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <div
                                        ng-bind-html="servicestatus.output | trustAsHtml"></div>
                            </div>
                        </div>

                        <div class="row" ng-show="servicestatus.perfdata">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('Perfdata'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                {{ servicestatus.perfdata }}
                            </div>
                        </div>

                        <div class="row d-flex justify-content-center margin-top-10">
                            <div class="btn-group" role="group" aria-label="Basic example">
                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Reset check time'); ?>"
                                        ng-click="reschedule(getObjectsForExternalCommandService())">
                                    <i class="fa fa-refresh"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Schedule maintenance'); ?>"
                                        ng-click="serviceDowntime(getObjectsForExternalCommandService())">
                                    <i class="fa fa-power-off"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Acknowledge service status'); ?>"
                                        ng-show="servicestatus.current_state > 0"
                                        ng-click="acknowledgeService(getObjectsForExternalCommandService())">
                                    <i class="fa fa-user"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Passive transfer check result'); ?>"
                                        ng-click="submitServiceResult(getObjectsForExternalCommandService())">
                                    <i class="fa fa-download"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Enable flap detection'); ?>"
                                        ng-click="enableServiceFlapDetection(getObjectsForExternalCommandService())"
                                        ng-show="!servicestatus.flap_detection_enabled">
                                    <i class="fa fa-adjust"></i>
                                </button>
                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Disable flap detection'); ?>"
                                        ng-click="disableServiceFlapDetection(getObjectsForExternalCommandService())"
                                        ng-show="servicestatus.flap_detection_enabled">
                                    <i class="fa fa-adjust"></i>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row" ng-show="servicestatus.scheduled_downtime_depth > 0">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">

                            <div class="row">
                                <div class="col-lg-12">
                                    <div>
                                        <h4 class="no-padding">
                                            <i class="fa fa-power-off"></i>
                                            <?php echo __('The service is currently in a planned maintenance period'); ?>
                                        </h4>
                                    </div>
                                    <div class="padding-top-5">
                                        <?php echo __('Downtime was set by'); ?>
                                        <b>{{downtime.author_name}}</b>
                                        <?php echo __('with an duration of'); ?>
                                        <b>{{downtime.duration_for_humans}}</b>.
                                    </div>
                                    <div class="padding-top-5">
                                        <small>
                                            <?php echo __('Start time:'); ?>
                                            {{ downtime.scheduled_start_time }}
                                            <?php echo __('End time:'); ?>
                                            {{ downtime.scheduled_end_time }}
                                        </small>
                                    </div>
                                    <div class="padding-top-5">
                                        <?php echo __('Comment: '); ?>
                                        {{downtime.comment_data}}
                                    </div>
                                </div>

                                <div class="col-lg-12">
                                    <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                        <button
                                                class="btn btn-xs btn-danger pull-right"
                                                ng-if="downtime.is_cancellable"
                                                ng-click="confirmServiceDowntimeDelete(getObjectsForDowntimeDelete())">
                                            <i class="fa fa-trash"></i> <?php echo __('Cancel'); ?>
                                        </button>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row" ng-show="servicestatus.problem_has_been_acknowledged">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">
                            <div>
                                <h4 class="no-padding">
                                    <i class="fa fa-user" ng-show="!acknowledgement.is_sticky"></i>
                                    <i class="far fa-user" ng-show="acknowledgement.is_sticky"></i>
                                    <?php echo __('State of service is acknowledged'); ?>
                                    <span ng-show="acknowledgement.is_sticky">
                                        (<?php echo __('Sticky'); ?>)
                                    </span>
                                </h4>
                            </div>
                            <div class="padding-top-5">
                                <?php echo __('Acknowledgement was set by'); ?>
                                <b>{{acknowledgement.author_name}}</b>
                                <?php echo __('at'); ?>
                                {{acknowledgement.entry_time}}
                            </div>
                            <div class="padding-top-5">
                                <?php echo __('Comment: '); ?>
                                <div style="display:inline"
                                     ng-bind-html="acknowledgement.comment_data_html | trustAsHtml"></div>
                            </div>
                        </div>
                    </div>
                </div>


                <div class="row" ng-show="servicestatus.is_flapping">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">
                            <div>
                                <h4 class="no-padding txt-color-orangeDark">
                                    <i class="fa fa-exclamation-triangle"></i>
                                    <?php echo __('The state of this service is currently flapping!'); ?>
                                </h4>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row padding-top-10" ng-show="mergedService.has_graph">
                    <div class="col-lg-12">
                        <h5>
                            <i class="fa fa-area-chart"></i>
                            <?php echo __('Service graph'); ?>
                        </h5>
                    </div>
                </div>

                <div class="row" ng-show="mergedService.has_graph">
                    <div class="col-lg-12 padding-10">
                        <div id="graph_legend" class="graph_legend"></div>
                        <div id="graph_data_tooltip"></div>
                        <div id="graphCanvas" style="height: 150px;"></div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                    <button type="button" class="btn btn-success"
                            data-dismiss="modal"
                            ui-sref="ServicesBrowser({hostuuid:servicestatus.hostname, serviceuuid:servicestatus.service_description})">
                        <?php echo __('Open details'); ?>
                    </button>
                <?php endif; ?>
                <button type="button" class="btn btn-default" data-dismiss="modal">
                    <?php echo __('Close'); ?>
                </button>
            </div>
        </div>
    </div>
</div>
<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-service callback="showFlashMsg"></reschedule-service>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <service-downtime callback="showFlashMsg"></service-downtime>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
    <submit-service-result max-check-attempts="{{servicestatus.max_check_attempts}}"
                           callback="showFlashMsg"></submit-service-result>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-service callback="showFlashMsg"></acknowledge-service>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
    <enable-service-flap-detection callback="showFlashMsg"></enable-service-flap-detection>
    <disable-service-flap-detection callback="showFlashMsg"></disable-service-flap-detection>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
    <mass-delete-service-downtimes delete-url="/externalcommands/cancel_downtime"
                                   callback="showFlashMsg"></mass-delete-service-downtimes>
<?php endif; ?>
