<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <a ui-sref="ServicesIndex">
                <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
            <a ui-sref="ServicesBrowser({hostuuid: servicestatus.hostname ,serviceuuid: servicestatus.service_description})">
                <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
            </a>
        <?php else: ?>
            <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <i class="fas fa-history"></i> <?php echo __('State history'); ?>
    </li>
</ol>

<servicemenu servicestatus="servicestatus" showbackbutton="true" ng-if="servicestatus"></servicemenu>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Service'); ?>
                    <span class="fw-300">
                        <i><?php echo __('state history'); ?></i>
                    </span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by output'); ?>"
                                                   ng-model="filter_output"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Service status'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterOk"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateOk"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-ok"
                                                       for="statusFilterOk"><?php echo __('Ok'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterWarning"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateWarning"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-warning"
                                                       for="statusFilterWarning"><?php echo __('Warning'); ?></label>
                                            </div>
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterCritical"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateCritical"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-critical"
                                                       for="statusFilterCritical"><?php echo __('Critical'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnknown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUnknown"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unknown"
                                                       for="statusFilterUnknown"><?php echo __('Unknown'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm" role="grid">
                            <thead>
                            <tr>
                                <th ng-click="orderBy('state')" class="width-120 cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('state')"></i>
                                    <?php echo __('State'); ?>
                                </th>
                                <th ng-click="orderBy('state_time')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('state_time')"></i>
                                    <?php echo __('Date'); ?>
                                </th>
                                <th class="width-120">
                                    <?php echo __('Check attempt'); ?>
                                </th>
                                <th class="width-80" ng-click="orderBy('is_hardstate')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('is_hardstate')"></i>
                                    <?php echo __('State type'); ?>
                                </th>
                                <th ng-click="orderBy('output')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('output')"></i>
                                    <?php echo __('Service output'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="servicestate in servicestatehistory">
                                <td class="text-center">
                                    <servicestatusicon state="servicestate.state"></servicestatusicon>
                                </td>
                                <td>
                                    {{servicestate.state_time}}
                                </td>
                                <td class="text-center">
                                    {{servicestate.current_check_attempt}}/{{servicestate.max_check_attempts}}
                                </td>
                                <td class="text-center">
                                        <span
                                                class="badge text-uppercase badge-{{ getColorOfState(servicestate.state) }}"
                                                ng-show="servicestate.is_hardstate">
                                            <?php echo __('hard state'); ?>
                                        </span>
                                    <span
                                            class="badge text-uppercase opacity-50 badge-{{ getColorOfState(servicestate.state) }}"
                                            ng-show="!servicestate.is_hardstate">
                                            <?php echo __('soft state'); ?>
                                        </span>
                                </td>
                                <td>
                                    {{servicestate.output}}
                                </td>
                            </tr>
                            <tr ng-show="servicestatehistory.length == 0">
                                <td colspan="5" class="text-center txt-color-red">
                                    <?php echo __('No results found'); ?>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
