<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fas fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'users')): ?>
            <a ui-sref="UsersIndex">
                <i class="fas fa-user"></i> <?php echo __('Users'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-user"></i> <?php echo __('Users'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-list"></i> <?php echo __('Overview'); ?>
    </li>
</ol>

<!-- ANGAULAR DIRECTIVES -->
<mass-delete></mass-delete>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Users'); ?>
                    <span class="fw-300">
                        <i><?php echo __('overview'); ?></i>
                    </span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <div class="padding-right-5">
                        <a ui-sref="UsersAdd" class="btn btn-xs btn-success">
                            <i class="fas fa-plus"></i>
                            <?php echo __('New local user'); ?>
                        </a>
                    </div>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>

            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-user"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by user name'); ?>"
                                                   ng-model="filter.Users.username"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by first name'); ?>"
                                                   ng-model="filter.Users.firstname"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by last name'); ?>"
                                                   ng-model="filter.Users.lastname"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-12 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group input-group-sm">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-users"></i></span>
                                            </div>
                                            <select
                                                id="UserRoles"
                                                data-placeholder="<?php echo __('Filter by user role'); ?>"
                                                class="form-control"
                                                chosen="usergroups"
                                                multiple
                                                ng-model="filter.Users.usergroup_id"
                                                ng-options="usergroup.key as usergroup.value for usergroup in usergroups">
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm" role="grid">
                            <thead>
                            <tr>
                                <th class="no-sort width-15">
                                    <i class="fa fa-check-square"></i>
                                </th>
                                <th ng-click="orderBy('Users.username')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Users.username')"></i>
                                    <?php echo __('Username'); ?>
                                </th>
                                <th ng-click="orderBy('Users.firstname')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Users.firstname')"></i>
                                    <?php echo __('First name'); ?>
                                </th>
                                <th ng-click="orderBy('Users.lastname')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Users.lastname')"></i>
                                    <?php echo __('Last name'); ?>
                                </th>
                                <th ng-click="orderBy('Usergroups.name')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Usergroups.name')"></i>
                                    <?php echo __('User role'); ?>
                                </th>
                                <th class="text-center width-75">
                                    <i class="fa fa-cog fa-lg"></i>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="user in users">
                                <td class="text-center" class="width-15">
                                    <?php if ($this->Acl->hasPermission('delete', 'users')): ?>
                                        <input type="checkbox"
                                               ng-if="user.id !== myUserId"
                                               ng-model="massChange[user.id]">
                                    <?php endif; ?>
                                </td>
                                <td> {{ user.username }}</td>
                                <td> {{ user.firstname }}</td>
                                <td> {{ user.lastname }}</td>
                                <td> {{ user.usergroup.name }}</td>
                                <td class="text-center">
                                    <div class="btn-group btn-group-xs">

                                        <?php if ($this->Acl->hasPermission('edit', 'users')): ?>
                                            <a ui-sref="UsersEdit({id: user.id})"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fas fa-cog"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fas fa-cog"></i>
                                            </a>
                                        <?php endif; ?>

                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>

                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('edit', 'users')): ?>
                                                <a ui-sref="UsersEdit({id: user.id})"
                                                   class="dropdown-item">
                                                    <i class="fa fa-cog"></i>
                                                    <?php echo __('Edit'); ?>
                                                </a>
                                            <?php endif; ?>

                                            <?php if ($this->Acl->hasPermission('delete', 'users')): ?>
                                                <div class="dropdown-divider" ng-if="user.id !== myUserId"></div>
                                                <a ng-click="confirmDelete(getObjectForDelete(user))"
                                                   ng-if="user.id !== myUserId"
                                                   href="javascript:void(0);"
                                                   class="dropdown-item txt-color-red">
                                                    <i class="fas fa-trash"></i>
                                                    <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>

                                    </div>
                                </td>
                            </tr>

                            <tr ng-show="users.length == 0">
                                <td colspan="8" class="text-center txt-color-red">
                                    <?php echo __('No results found'); ?>
                                </td>
                            </tr>

                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="Usergroups.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <?php if ($this->Acl->hasPermission('delete', 'users')): ?>
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="selectAll()" class="pointer">
                                        <i class="fas fa-lg fa-check-square"></i>
                                        <?php echo __('Select all'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="undoSelection()" class="pointer">
                                        <i class="fas fa-lg fa-square"></i>
                                        <?php echo __('Undo selection'); ?>
                                    </span>
                                </div>

                                <div class="col-xs-12 col-md-2 txt-color-red">
                                    <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Delete selected'); ?>
                                    </span>
                                </div>
                            <?php endif; ?>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
