<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace App\View\Helper;

use Cake\View\Helper;

/**
 * Class AclHelper
 */
class AclHelper extends Helper {

    /**
     * Default configuration.
     *
     * @var array
     */
    protected $_defaultConfig = [];

    /**
     * @param string $action
     * @param string $controller
     * @param string $plugin
     * @return bool
     */
    public function hasPermission(string $action, string $controller, string $plugin = '') {
        $controller = strtolower($controller);
        $action = strtolower($action);
        $plugin = strtolower($plugin);

        $ACLPERMISSIONS = $this->_View->get('ACLPERMISSIONS');
        if ($plugin === null || $plugin === '') {
            return isset($ACLPERMISSIONS[$controller][$action]);
        }

        return isset($ACLPERMISSIONS[$plugin][$controller][$action]);
    }
}
