<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core\AngularJS\Request;


use App\Filter\BaseFilter;

class NotificationsOverviewControllerRequest extends AngularRequest {

    /**
     * @var array
     */
    protected $filters = [
        'host'    => [
            'like' => [
                'NotificationHosts.output',
                'Hosts.name',
                'Contacts.name',
                'Commands.name'
            ]
        ],
        'service' => [
            'like' => [
                'NotificationServices.output',
                'Hosts.name',
                'Contacts.name',
                'Commands.name',
                'servicename'
            ]
        ]
    ];

    protected $ServiceStateField = 'NotificationServices.state';

    protected $HostStateField = 'NotificationHosts.state';

    public function getServiceFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['service']);
    }

    public function getHostFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['host']);
    }

}
