<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Graphite;


class GraphiteMetric {

    /**
     * @var string
     */
    private $hostUuid;

    /**
     * @var string
     */
    private $serviceUuid;

    /**
     * @var string
     */
    private $metric;

    /**
     * GraphiteMetric constructor.
     * @param string $hostUuid
     * @param string $serviceUuid
     * @param string $metric
     */
    public function __construct($hostUuid, $serviceUuid, $metric) {
        $this->hostUuid = $hostUuid;
        $this->serviceUuid = $serviceUuid;
        $this->metric = $this->replaceIllegalCharacters($metric);
    }

    public function getMetricPath() {
        return sprintf(
            '%s.%s.%s',
            $this->hostUuid,
            $this->serviceUuid,
            $this->metric
        );
    }

    public function replaceIllegalCharacters($str) {
        return preg_replace('/[^a-zA-Z^0-9\-\.]/', '_', $str);
    }

}
