<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\InitialDatabase;

use App\Model\Table\UsergroupsTable;

/**
 * Class Usergroup
 * @package itnovum\openITCOCKPIT\InitialDatabase
 * @property UsergroupsTable $Table
 */
class Usergroup extends Importer {

    /**
     * @return bool
     */
    public function import() {
        if ($this->isTableEmpty()) {
            $data = $this->getData();
            foreach ($data as $record) {
                $entity = $this->Table->newEmptyEntity();
                $entity = $this->patchEntityAndKeepAllIds($entity, $record);
                $this->Table->save($entity);
            }
        }

        return true;
    }

    /**
     * @return array
     */
    public function getData() {
        $data = [
            (int)0 => [
                'id'          => '1',
                'name'        => 'Administrator',
                'description' => '',
                'created'     => '2015-08-19 14:57:42',
                'modified'    => '2015-08-19 14:57:42'
            ],
            (int)1 => [
                'id'          => '2',
                'name'        => 'Viewer',
                'description' => '',
                'created'     => '2015-08-19 15:00:36',
                'modified'    => '2015-08-19 15:00:36'
            ]
        ];

        return $data;
    }
}
