<?php

namespace App\Test\Fixture;

use Cake\TestSuite\Fixture\TestFixture;

/**
 * HostStatehistoryFixture
 *
 */
class HostStatehistoryFixture extends TestFixture {

    /**
     * Table name
     *
     * @var string
     */
    public $table = 'statusengine_host_statehistory';

    /**
     * Fields
     *
     * @var array
     */
    // @codingStandardsIgnoreStart
    public $fields = [
        'hostname'              => ['type' => 'string', 'length' => 255, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'state_time'            => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'state_change'          => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'state'                 => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'is_hardstate'          => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'current_check_attempt' => ['type' => 'integer', 'length' => 3, 'unsigned' => true, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'max_check_attempts'    => ['type' => 'integer', 'length' => 3, 'unsigned' => true, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'last_state'            => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'last_hard_state'       => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'output'                => ['type' => 'string', 'length' => 1024, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'long_output'           => ['type' => 'string', 'length' => 8192, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        '_indexes'              => [
            'hostname_time' => ['type' => 'index', 'columns' => ['hostname', 'state_time'], 'length' => []],
        ],
        '_options'              => [
            'engine'    => 'InnoDB',
            'collation' => 'utf8_general_ci'
        ],
    ];
    // @codingStandardsIgnoreEnd

    /**
     * Records
     *
     * @var array
     */
    public $records = [
        [
            'hostname'              => 'Lorem ipsum dolor sit amet',
            'state_time'            => 1,
            'state_change'          => 1,
            'state'                 => 1,
            'is_hardstate'          => 1,
            'current_check_attempt' => 1,
            'max_check_attempts'    => 1,
            'last_state'            => 1,
            'last_hard_state'       => 1,
            'output'                => 'Lorem ipsum dolor sit amet',
            'long_output'           => 'Lorem ipsum dolor sit amet'
        ],
    ];
}
