angular.module('openITCOCKPIT')
    .controller('ServicechecksIndexController', function($scope, $http, $stateParams, SortService){

        $scope.currentPage = 1;
        $scope.useScroll = true;

        SortService.setSort('start_time');
        SortService.setDirection('desc');

        /** Filter settings **/
        var defaultFilter = function(){
            $scope.stateOk = true;
            $scope.stateWarning = true;
            $scope.stateCritical = true;
            $scope.stateUnknown = true;
            $scope.current_state = [];
            $scope.filter_output = '';
            $scope.showFilter = false;
        };

        defaultFilter();
        /** End filter Settings **/

        $scope.init = true;

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };

        $scope.load = function(){
            $http.get("/servicechecks/index.json", {
                params: {
                    'scroll': $scope.useScroll,
                    'sort': SortService.getSort(),
                    'page': $scope.currentPage,
                    'direction': SortService.getDirection(),
                    'filter[Servicechecks.service_description]': $stateParams.serviceuuid,
                    'filter[Servicechecks.state][]': $scope.current_state,
                    'filter[Servicechecks.output]': $scope.filter_output
                }
            }).then(function(result){
                $scope.servicechecks = result.data.servicechecks;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });
        };

        $scope.loadServicestatus = function(){
            $http.get("/services/index.json", {
                params: {
                    'filter[Servicestatus.service_description]': $stateParams.serviceuuid
                }
            }).then(function(result){
                $scope.servicestatus = result.data.servicestatus[0];
            });
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.getColorOfState = function(state){
            if(state === 0){
                return 'success';
            }
            if(state === 1){
                return 'warning';
            }
            if(state === 2){
                return 'danger';
            }
            if(state === 3){
                return 'secondary';
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.$watchGroup(['stateOk', 'stateWarning', 'stateCritical', 'stateUnknown', 'filter_output'], function(){
            if($scope.init){
                return;
            }
            $scope.current_state = [];
            if($scope.stateOk){
                $scope.current_state.push('ok');
            }
            if($scope.stateWarning){
                $scope.current_state.push('warning');
            }
            if($scope.stateCritical){
                $scope.current_state.push('critical');
            }
            if($scope.stateUnknown){
                $scope.current_state.push('unknown');
            }
            $scope.load();
        });

        SortService.setCallback($scope.load);
        SortService.triggerReload();

        $scope.loadServicestatus();


        if($("[rel=tooltip]").length){
            $("[rel=tooltip]").tooltip();
        }

    });
