# openitcockpit-receiver
openITCOCKPIT Check Receiver for openITCOCKPITs monitoring agent

## Basic usage

```
bin/poller.php poller -H 2ad49ebf-ea72-4a16-85d7-392e3d9fbc11 -c /opt/openitc/receiver/etc/production.json --dryrun --verbose
```

Pass `--http` to disable `WARNING: Unencrypted HTTP connection used!`
```
bin/poller.php poller -H 2ad49ebf-ea72-4a16-85d7-392e3d9fbc11 -c /opt/openitc/receiver/etc/production.json --dryrun --verbose --http
```

## Sample configuration file

"args_comment" is only a hint for config generation and will be ignored by the receiver script
```JSON
{
    "192.168.1.100": {
        "name": "test host",
        "address": "test.oitc.itn",
        "uuid": "0c9acb7d-cb4a-411e-bf6b-5f120f0acb1b",
        "checks": [
            {
                "plugin": "MemoryUsage",
                "servicename": "Memory usage percentage",
                "uuid": "8f5bd026-3286-4b6c-bca3-1cef980fa8d8",
                "args": [
                    75,
                    85
                ],
                "args_comment": "[warning, critical]"
            },
            {
                "plugin": "SwapUsage",
                "servicename": "Swap usage",
                "uuid": "5CD6836B-359D-4FF3-AF27-38C0C8D95EA3",
                "args": [
                    50,
                    60
                ],
                "args_comment": "[warning, critical]"
            },
            {
                "plugin": "DiskUsage",
                "servicename": "Disk usage of /dev/vda3",
                "uuid": "5CD6836B-359D-4FF3-AF27-38C0C8D95EA3",
                "args": [
                    80,
                    90,
                    "/dev/vda3"
                ],
                "args_comment": "[warning, critical, device]"
            },
            {
                "plugin": "DiskIO",
                "servicename": "Disk stats of: vda1",
                "uuid": "2c76f7dc-e799-4942-ba82-a34234673d8e",
                "args": [
                    "70",
                    "80",
                    "vda1"
                ]
            },
            {
                "plugin": "Process",
                "servicename": "Process naemon (strict = true)",
                "uuid": "3EB79CD2-B131-4CFB-A043-7FBDB8E1EF58",
                "args": [
                    50,
                    60,
                    50,
                    60,
                    2,
                    4,
                    "/opt/openitc/nagios/bin/naemon -d /etc/openitcockpit/nagios.cfg",
                    true
                ],
                "args_comment": "[cpu_warning, cpu_critical, memory_warning, memory_critical, amount_warning, amount_critical, match, strict]"
            },
            {
                "plugin": "Process",
                "servicename": "Process php-fpm (strict = false)",
                "uuid": "3EB79CD2-B131-4CFB-A043-7FBDB8E1EF58",
                "args": [
                    50,
                    60,
                    50,
                    60,
                    2,
                    4,
                    "php-fpm: pool www",
                    false
                ],
                "args_comment": "[cpu_warning, cpu_critical, memory_warning, memory_critical, amount_warning, amount_critical, match, strict]"
            },
            {
                "plugin": "CpuTotalPercentage",
                "servicename": "Cpu usage percentage",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA980F",
                "args": [
                    50,
                    60,
                    true
                ],
                "args_comment": "[warning, critical, per_core]"
            },
            {
                "plugin": "Temperature",
                "servicename": "Core temperature",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA980D",
                "args": [
                    30,
                    60,
                    true,
                    "coretemp"
                ],
                "args_comment": "[warning, crirtical, average, device]"
            },
            {
                "plugin": "Fan",
                "servicename": "Fan speed",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA980E",
                "args": [
                    2300,
                    3100,
                    false,
                    "thinkpad"
                ],
                "args_comment": "[warning, crirtical, average, device]"
            },
            {
                "plugin": "Battery",
                "servicename": "Battery consumption (percent)",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA980F",
                "args": [
                    25,
                    10
                ],
                "args_comment": "[warning, crirtical]"
            },
            {
                "plugin": "NetIO",
                "servicename": "enp0s31f6 network IO",
                "uuid": "3EB79CD2-B131-4CFB-A043-7FBDB8E1EF61",
                "args": [
                    20000,
                    80000,
                    5,
                    10,
                    5,
                    10,
                    "enp0s31f6"
                ],
                "args_comment": "[total_avg_bytes_warning, total_avg_bytes_critical, total_avg_error_warning, total_avg_error_critical, total_avg_drop_warning, total_avg_drop_critical, device]"
            },
            {
                "plugin": "NetStats",
                "servicename": "enp0s31f6 network stats",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA982A",
                "args": [
                    "warning",
                    "enp0s31f6"
                ],
                "args_comment": "[link_down_state, device]"
            },
            {
                "plugin": "NetStats",
                "servicename": "virbr0-nic network stats",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA982B",
                "args": [
                    "critical",
                    "virbr0-nic"
                ],
                "args_comment": "[link_down_state, device]"
            },
            {
                "plugin": "Customcheck",
                "servicename": "sleep 15 stats stats",
                "uuid": "41C48C93-2C8C-4B7C-A781-B23F13DA982C",
                "args": [
                    "sleep"
                ],
                "args_comment": "[name]"
            }
        ]
    }
}
```

# License
```
Copyright (C) 2015-2021  it-novum GmbH


openITCOCKPIT is dual licensed

1)
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.


This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

2)
If you purchased an openITCOCKPIT Enterprise Edition you can use this file
under the terms of the openITCOCKPIT Enterprise Edition licence agreement.
Licence agreement and licence key will be shipped with the order
confirmation.
```
