<?php
// Copyright (C) <2018>  <it-novum GmbH>
//
// This file is dual licensed
//
// 1.
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, version 3 of the License.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// 2.
//  If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//  under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//  License agreement and license key will be shipped with the order
//  confirmation.

namespace itnovum\openITCOCKPIT\Checks\Receiver;


class NagiosService {

    const STATUS_OK = 0;
    const STATUS_WARNING = 1;
    const STATUS_CRITICAL = 2;
    const STATUS_UNKNOWN = 3;

    /**
     * @param $msg
     * @param $exitCode
     * @param bool $doStatusPrefix
     */
    public static function doExit($msg, $exitCode, $doStatusPrefix = true) {
        if ($doStatusPrefix) {
            $msg = self::prefixOutput($msg, $exitCode);
        }
        echo $msg;
        exit($exitCode);
    }

    /**
     * @param string $msg
     * @param int $exitCode
     * @return string
     */
    public static function prefixOutput($msg, $exitCode) {
        switch ($exitCode) {
            case self::STATUS_OK:
                $prefix = 'OK: ';
                break;

            case self::STATUS_WARNING:
                $prefix = 'WARNING: ';
                break;

            case self::STATUS_CRITICAL:
                $prefix = 'CRITICAL: ';
                break;

            default:
                $prefix = 'UNKNOWN: ';
                break;
        }

        return $prefix . $msg;
    }

}